#ifndef my_S11NNODELISTVIEWITEM_HPP_INCLUDED
#define my_S11NNODELISTVIEWITEM_HPP_INCLUDED 1

#include <s11n.net/s11n/s11nlite.hpp>
#include "qlistview.h"

namespace s11n { namespace qt {

        class S11nNodeListViewItem : public QListViewItem
        {
        public:
                typedef s11nlite::node_type node_type;

                S11nNodeListViewItem() : QListViewItem((QListViewItem*)0),
                                         m_node(0)
                {
                        this->build_tree();
                }
                /**
                   This object does NOT own node, and node must out-live this object.
                 */
                S11nNodeListViewItem( node_type & node, QListViewItem *parent  ) : QListViewItem(parent),
                                                                                     m_node(&node)
                {
                        this->build_tree();
                }

                /**
                   This object does NOT own node, and node must out-live this object.
                 */
                S11nNodeListViewItem( node_type & node, QListView *parent  ) : QListViewItem(parent),
                                                                                     m_node(&node)
                {
                        this->build_tree();
                }

                virtual ~S11nNodeListViewItem()
                {
                }

                virtual void setText( int col, const QString & txt );

                /**
                   Returns this object's data node.
                   Feel free to modify it, but please do not delete it!
                 */
                node_type * node() const { return this->m_node; }
                        

        private:
                void build_tree();
                s11nlite::node_type * m_node;

        };


} }  // namespace s11n::qt


#endif // my_S11NNODELISTVIEWITEM_HPP_INCLUDED
